Home | History | Annotate | Download | only in tests-m32
      1 #!/bin/sh
      2 #
      3 # Ensure that strace can detach from running processes.
      4 #
      5 # Copyright (c) 2013-2015 Dmitry V. Levin <ldv (at] altlinux.org>
      6 # Copyright (c) 2014-2017 The strace developers.
      7 # All rights reserved.
      8 #
      9 # Redistribution and use in source and binary forms, with or without
     10 # modification, are permitted provided that the following conditions
     11 # are met:
     12 # 1. Redistributions of source code must retain the above copyright
     13 #    notice, this list of conditions and the following disclaimer.
     14 # 2. Redistributions in binary form must reproduce the above copyright
     15 #    notice, this list of conditions and the following disclaimer in the
     16 #    documentation and/or other materials provided with the distribution.
     17 # 3. The name of the author may not be used to endorse or promote products
     18 #    derived from this software without specific prior written permission.
     19 #
     20 # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
     21 # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
     22 # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
     23 # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
     24 # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
     25 # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
     26 # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
     27 # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
     28 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
     29 # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
     30 
     31 . "${srcdir=.}/init.sh"
     32 
     33 run_prog_skip_if_failed \
     34 	kill -0 $$
     35 
     36 check_prog sleep
     37 
     38 set -e
     39 
     40 ../set_ptracer_any sh -c "echo > $LOG; while :; do :; done" > /dev/null &
     41 
     42 while ! [ -s "$LOG" ]; do
     43 	kill -0 $! 2> /dev/null ||
     44 		fail_ 'set_ptracer_any sh failed'
     45 	$SLEEP_A_BIT
     46 done
     47 
     48 tracee_pid=$!
     49 
     50 cleanup()
     51 {
     52 	set +e
     53 	kill $tracee_pid
     54 	wait $tracee_pid 2> /dev/null
     55 	return 0
     56 }
     57 
     58 $STRACE -p $tracee_pid 2> "$LOG" &
     59 
     60 while ! grep -F "Process $tracee_pid attached" "$LOG" > /dev/null; do
     61 	kill -0 $! 2> /dev/null || {
     62 		cleanup
     63 		dump_log_and_fail_with "$STRACE -p failed to attach"
     64 	}
     65 	$SLEEP_A_BIT
     66 done
     67 
     68 kill -INT $!
     69 wait $!
     70 
     71 grep -F "Process $tracee_pid detached" "$LOG" > /dev/null || {
     72 		cleanup
     73 		dump_log_and_fail_with "$STRACE -p failed to detach"
     74 	}
     75 
     76 if [ -f /proc/self/status ]; then
     77 	$SLEEP_A_BIT
     78 	test -d /proc/$tracee_pid || {
     79 		cleanup
     80 		dump_log_and_fail_with 'tracee died after detach'
     81 	}
     82 	grep_pid_status "$tracee_pid" '^State:.*R (running)' > /dev/null || {
     83 		grep_pid_status "$tracee_pid" '^State:'
     84 		cleanup
     85 		dump_log_and_fail_with 'tracee is not running after detach'
     86 	}
     87 fi
     88 
     89 cleanup
     90 exit 0
     91